
without warning

-- English numbers include file

-- By: James Jonathan Cook
-- Created: 2/17/2016
-- Last Modified: 3/25/2016

-- for those who cannot count up to one trillion (1,000,000,000,000)

-- for those having a hard time with english numbers.

-- Doubles have 15 significant digits. (one quadrillion)
-- https://en.wikipedia.org/wiki/Orders_of_magnitude_(numbers)
-- https://en.wikipedia.org/wiki/Double-precision_floating-point_format


-- Example: zero through one trillion dollars

-- typedef struct {
--  int quot;
--  int rem;
-- } div_t;

-- main function:
-- function number_to_natural_language(whole_number n)

-- one to:
-- limit = quadrillion - one

-- output:
-- 999999999999999:
-- nine hundred and ninety nine trillion 
-- nine hundred and ninety nine billion 
-- nine hundred and ninety nine million 
-- nine hundred and ninety nine thousand 
-- nine hundred and ninety nine

-- constant
-- 
-- tzero  = "zero",
-- tone   = "one",
-- ttwo   = "two",
-- tthree = "three",
-- tfour  = "four",
-- tfive  = "five",
-- tsix   = "six",
-- tseven = "seven",
-- teight = "eight",
-- tnine  = "nine",
-- 
-- tten       = "ten",
-- televen    = "eleven",
-- ttwelve    = "twelve",
-- tthirteen  = "thirteen",
-- tfourteen  = "fourteen",
-- tfifteen   = "fifteen",
-- tsixteen   = "sixteen",
-- tseventeen = "seventeen",
-- teighteen  = "eighteen",
-- tnineteen  = "nineteen",
-- 
-- ttwenty  = "twenty",
-- tthirty  = "thirty",
-- tforty   = "forty",
-- tfifty   = "fifty",
-- tsixty   = "sixty",
-- tseventy = "seventy",
-- teighty  = "eighty",
-- tninety  = "ninety",
-- 
-- thundred = "hundred",
-- thousand = "thousand",
-- tmillion = "million",
-- tbillion = "billion",
-- ttrillion = "trillion",
-- quadrillion = "quadrillion",
-- $

global constant

zero  = 0,
one   = 1,
two   = 2,
three = 3,
four  = 4,
five  = 5,
six   = 6,
seven = 7,
eight = 8,
nine  = 9


global constant

ten       = 10,
eleven    = ten + one,
twelve    = ten + two,
thirteen  = ten + three,
fourteen  = ten + four,
fifteen   = ten + five,
sixteen   = ten + six,
seventeen = ten + seven,
eighteen  = ten + eight,
nineteen  = ten + nine


global constant without_anything = "zero"

global constant one_place = {
"one",
"two",
"three",
"four",
"five",
"six",
"seven",
"eight",
"nine",
"ten",
"eleven",
"twelve",
"thirteen",
"fourteen",
"fifteen",
"sixteen",
"seventeen",
"eighteen",
"nineteen"
}

global constant

twenty  = ten * two,
thirty  = ten * three,
forty   = ten * four,
fifty   = ten * five,
sixty   = ten * six,
seventy = ten * seven,
eighty  = ten * eight,
ninety  = ten * nine


global constant ten_place = {
"ten",
"twenty",
"thirty",
"forty",
"fifty",
"sixty",
"seventy",
"eighty",
"ninety"
}

global constant

hundred = 100,

one_hundred   = hundred * one,
two_hundred   = hundred * two,
three_hundred = hundred * three,
four_hundred  = hundred * four,
five_hundred  = hundred * five,
six_hundred   = hundred * six,
seven_hundred = hundred * seven,
eight_hundred = hundred * eight,
nine_hundred  = hundred * nine


global constant

thousand = 1000,

one_thousand   = thousand * one,
two_thousand   = thousand * two,
three_thousand = thousand * three,
four_thousand  = thousand * four,
five_thousand  = thousand * five,
six_thousand   = thousand * six,
seven_thousand = thousand * seven,
eight_thousand = thousand * eight,
nine_thousand  = thousand * nine


global constant

million  = thousand * thousand,
billion  = thousand * million,
trillion = thousand * billion,

quadrillion = thousand * trillion,

limit = quadrillion - one


global constant powers_of_ten = {
"ten",
"hundred",
"thousand"
}

global constant powers_of_thousand = {
"thousand",
"million",
"billion",
"trillion",
"quadrillion"
}


global type number(atom n)
--done.
    return n <= limit and n >= zero
end type

type number_less_than_hundred(atom n)
--done.
    return n < hundred and n >= zero
end type

type number_less_than_thousand(atom n)
--done.
    return n < thousand and n >= zero
end type

type number_less_than_million(atom n)
--done.
    return n < million and n >= zero
end type

type number_less_than_billion(atom n)
--done.
    return n < billion and n >= zero
end type

type number_less_than_trillion(atom n)
--done.
    return n < trillion and n >= zero
end type


function div(atom number, atom denom)
--done.
	atom quot, rem
	quot = floor(number / denom)
	rem = remainder(number, denom)
	return {quot, rem}
end function


function less_than_hundred(number_less_than_hundred n)
--done.
    atom rem, quot
    sequence st, E
    integer index
    st = ""
    quot = zero
    rem = zero
    if twenty <= n and n < hundred then
    -- if n is between twenty and (one hundred minus one) then
	E = div(n, ten)
	quot = E[1]
	rem = E[2]
	index = quot
	st = ten_place[index]
	n = rem
	if zero < n then
	    st = st & " "
	end if
    end if
    if one <= n and n < twenty then
    -- if n is between one and (twenty minus one) then
	E = div(n,twenty)
	quot = E[1]
	rem = E[2]
	index = rem
	st = st & one_place[index]
    end if
    return {st}
end function


function less_than_thousand(number_less_than_thousand n)
--done.
    atom rem, quot
    sequence st, E, tmp
    integer index
    st = ""
    index = zero
    if hundred <= n and n < thousand then
    -- if n is between one hundred and (one thousand minus one)
	E = div(n, hundred)
	quot = E[1]
	rem = E[2]
	index = quot
	st = one_place[index]
	st = st & " " & powers_of_ten[two]
	n = rem
	if zero < n then
	    st = st & " and "
	end if
    end if
    if n < hundred then
	E = less_than_hundred(n)
	tmp = E[1]
	st = st & tmp
    end if
    return {st}
end function

function less_than_million(number_less_than_million n)
--done.
    atom rem, quot
    sequence tmp, st, E
    integer index
    st = ""
    index = zero
    if thousand <= n and n < million then
    -- if n is between one thousand and (one million minus one)
	E = div(n, thousand)
	quot = E[1]
	rem = E[2]
	index = quot
	E = less_than_thousand(index)
	st = E[1]
	st = st & " " & powers_of_thousand[one]
	n = rem
	if zero < n then
	    st = st & " "
	end if
    end if
    if n < thousand then
	E = less_than_thousand(n)
	tmp = E[1]
	st = st & tmp
    end if
    return {st}
end function

function less_than_billion(number_less_than_billion n)
--done.
    atom rem, quot
    sequence tmp, st, E
    integer index
    st = ""
    index = zero
    if million <= n and n < billion then
    -- if n is between million and (billion minus one)
	E = div(n, million)
	quot = E[1]
	rem = E[2]
	index = quot
	E = less_than_million(index)
	st = E[1]
	st = st & " " & powers_of_thousand[two]
	n = rem
	if zero < n then
	    st = st & " "
	end if
    end if
    if n < million then
	E = less_than_million(n)
	tmp = E[1]
	st = st & tmp
    end if
    return {st}
end function

function less_than_trillion(number_less_than_trillion n)
--done.
    atom rem, quot
    sequence tmp, st, E
    integer index
    st = ""
    index = zero
    if billion <= n and n < trillion then
    -- if n is between billion and (trillion minus one)
	E = div(n, billion)
	quot = E[1]
	rem = E[2]
	index = quot
	E = less_than_billion(index)
	st = E[1]
	st = st & " " & powers_of_thousand[three]
	n = rem
	if zero < n then
	    st = st & " "
	end if
    end if
    if n < billion then
	E = less_than_billion(n)
	tmp = E[1]
	st = st & tmp
    end if
    return {st}
end function

function less_than_limit(number n)
--done.
    atom rem, quot
    sequence tmp, st, E
    integer index
    st = ""
    index = zero
    if trillion <= n and n < quadrillion then
    -- if n is between trillion and (quadrillion minus one)
	E = div(n, trillion)
	quot = E[1]
	rem = E[2]
	index = quot
	E = less_than_trillion(index)
	st = E[1]
	st = st & " " & powers_of_thousand[four]
	n = rem
	if zero < n then
	    st = st & " "
	end if
    end if
    if n < trillion then
	E = less_than_trillion(n)
	tmp = E[1]
	st = st & tmp
    end if
    return {st}
end function


global function number_to_natural_language(number n)
--done.
    sequence st, E
    if n = zero then
	return without_anything
    end if
    E = less_than_limit(n)
    st = E[1]
    return st
end function

-- up to 15 significant digits.

--end of file.
